"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var nodemailer_1 = require("nodemailer");
var util_1 = require("util");
var MailListener_1 = __importDefault(require("./MailListener"));
var Email = /** @class */ (function (_super) {
    __extends(Email, _super);
    function Email(auth) {
        var _this = _super.call(this) || this;
        _this.auth = auth;
        var _a = _this.auth, account = _a.account, defaults = _a.defaults;
        var transport = _this.auth.transport;
        var smtp = _this.auth.smtp;
        if (transport) {
            _this.mailer = transport;
        }
        else if (smtp) {
            _this.mailer = nodemailer_1.createTransport(__assign(__assign({}, smtp), { auth: account }), defaults);
        }
        else {
            throw new Error('Either `smtp` or `transport` option must be set in `auth` object.');
        }
        return _this;
    }
    Email.prototype.connect = function () {
        var _this = this;
        var _a = this.auth, imap = _a.imap, account = _a.account;
        this.listener = new MailListener_1.default(__assign(__assign({}, imap), account));
        var listener = this.listener;
        listener.on('imap:connected', function () { return _this.emit('imap:connected'); });
        listener.on('imap:disconnected', function () { return _this.emit('imap:disconnected'); });
        listener.on('incoming', function (id) { return _this.emit('arrived', id); });
        listener.on('mail', function (mail) { return _this.emit('mail', mail); });
    };
    Email.prototype.sendMail = function (options) {
        var sendMailPromise = util_1.promisify(this.mailer.sendMail.bind(this.mailer));
        return sendMailPromise(options);
    };
    Email.prototype.end = function () {
        if (this.listener) {
            this.listener.end();
        }
    };
    return Email;
}(events_1.EventEmitter));
exports.default = Email;
//# sourceMappingURL=Email.js.map