"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Separator = void 0;
/**
 * Separator functions take details from the email and separate them into their own keys
 * on the object. For example, a separator might read email attachments and
 */
var Separator = /** @class */ (function () {
    function Separator() {
    }
    Separator.prototype.filterAttachments = function (attachments, contentType) {
        return attachments.filter(function (_a) {
            var attachmentContentType = _a.contentType;
            return attachmentContentType === contentType;
        });
    };
    Separator.prototype.hasAttachmentsOfType = function (attachments, contentType) {
        return this.filterAttachments(attachments, contentType).length > 0;
    };
    return Separator;
}());
exports.Separator = Separator;
exports.default = Separator;
//# sourceMappingURL=Separator.js.map