"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateEmail = exports.getCarrier = exports.carriers = void 0;
exports.carriers = {
    '3RiverWireless': '[number]@sms.3rivers.net',
    'ACSWireless': '[number]@paging.acswireless.com',
    'Alltel': '[number]@message.alltel.com',
    'AT&T': '[number]@mms.att.net',
    'BellCanada': '[number]@bellmobility.ca',
    'BellMobility(Canada)': '[number]@txt.bell.ca',
    'BellMobility': '[number]@txt.bellmobility.ca',
    'BlueSkyFrog': '[number]@blueskyfrog.com',
    'BluegrassCellular': '[number]@sms.bluecell.com',
    'BoostMobile': '[number]@myboostmobile.com',
    'BPLMobile': '[number]@bplmobile.com',
    'CarolinaWestWireless': '[number]@cwwsms.com',
    'CellularOne': '[number]@sbcemail.com',
    'CellularSouth': '[number]@csouth1.com',
    'CentennialWireless': '[number]@cwemail.com',
    'CenturyTel': '[number]@messaging.centurytel.net',
    'Cingular(NowAT&T)': '[number]@txt.att.net',
    'Clearnet': '[number]@msg.clearnet.com',
    'Comcast': '[number]@comcastpcs.textmsg.com',
    'CorrWirelessCommunications': '[number]@corrwireless.net',
    'Dobson': '[number]@mobile.dobson.net',
    'EdgeWireless': '[number]@sms.edgewireless.com',
    'Fido': '[number]@fido.ca',
    'GoldenTelecom': '[number]@sms.goldentele.com',
    'Helio': '[number]@messaging.sprintpcs.com',
    'HoustonCellular': '[number]@text.houstoncellular.net',
    'IdeaCellular': '[number]@ideacellular.net',
    'IllinoisValleyCellular': '[number]@ivctext.com',
    'InlandCellularTelephone': '[number]@inlandlink.com',
    'MCI': '[number]@pagemci.com',
    'Metrocall': '[number]@page.metrocall.com',
    'Metrocall2-way': '[number]@my2way.com',
    'MetroPCS': '[number]@mymetropcs.com',
    'Microcell': '[number]@fido.ca',
    'MidwestWireless': '[number]@clearlydigital.com',
    'Mobilcomm': '[number]@mobilecomm.net',
    'MTS': '[number]@text.mtsmobility.com',
    'Nextel': '[number]@page.nextel.com',
    'OnlineBeep': '[number]@onlinebeep.net',
    'PCSOne': '[number]@pcsone.net',
    'PresidentsChoice': '[number]@txt.bell.ca',
    'PublicServiceCellular': '[number]@sms.pscel.com',
    'Qwest': '[number]@qwestmp.com',
    'RogersAT&TWireless': '[number]@pcs.rogers.com',
    'RogersCanada': '[number]@pcs.rogers.com',
    'Satellink': '[number]@satellink.net',
    'SouthwesternBell': '[number]@email.swbw.com',
    'Sprint': '[number]@messaging.sprintpcs.com',
    'Sumcom': '[number]@tms.suncom.com',
    'SurewestCommunicaitons': '[number]@mobile.surewest.com',
    'T-Mobile': '[number]@tmomail.net',
    'Telus': '[number]@msg.telus.com',
    'Ting': '[number]@mailmymobile.net',
    'Tracfone': '[number]@txt.att.net',
    'Triton': '[number]@tms.suncom.com',
    'Unicel': '[number]@utext.com',
    'USCellular': '[number]@email.uscc.net',
    'SoloMobile': '[number]@txt.bell.ca',
    'USWest': '[number]@uswestdatamail.com',
    'Verizon': '[number]@vzwpix.com',
    'VirginMobile': '[number]@vmobl.com',
    'VirginMobileCanada': '[number]@vmobile.ca',
    'WestCentralWireless': '[number]@sms.wcc.net',
    'WesternWireless': '[number]@cellularonewest.com',
    'ChennaiRPGCellular': '[number]@rpgmail.net',
    'ChennaiSkycell/Airtel': '[number]@airtelchennai.com',
    'Comviq': '[number]@sms.comviq.se',
    'DelhiAritel': '[number]@airtelmail.com',
    'DelhiHutch': '[number]@delhi.hutch.co.in',
    'DTT-Mobile': '[number]@t-mobile-sms.de',
    'Dutchtone/Orange-NL': '[number]@sms.orange.nl',
    'EMT': '[number]@sms.emt.ee',
    'Escotel': '[number]@escotelmobile.com',
    'GermanT-Mobile': '[number]@t-mobile-sms.de',
    'GoaBPLMobil': '[number]@bplmobile.com',
    'GujaratCelforce': '[number]@celforce.com',
    'JSMTele-Page': '[number]@jsmtel.com',
    'KeralaEscotel': '[number]@escotelmobile.com',
    'KolkataAirtel': '[number]@airtelkol.com',
    'Kyivstar': '[number]@smsmail.lmt.lv',
    'LauttamusCommunication': '[number]@e-page.net',
    'LMT': '[number]@smsmail.lmt.lv',
    'MaharashtraBPLMobile': '[number]@bplmobile.com',
    'MaharashtraIdeaCellular': '[number]@ideacellular.net',
    'ManitobaTelecomSystems': '[number]@text.mtsmobility.com',
    'Meteor': '[number]@mymeteor.ie',
    'MiWorld': '[number]@m1.com.sg',
    'Mobileone': '[number]@m1.com.sg',
    'Mobilfone': '[number]@page.mobilfone.com',
    'MobilityBermuda': '[number]@ml.bm',
    'MobistarBelgium': '[number]@mobistar.be',
    'MobitelTanzania': '[number]@sms.co.tz',
    'MobtelSrbija': '[number]@mobtel.co.yu',
    'Movistar': '[number]@correo.movistar.net',
    'MumbaiBPLMobile': '[number]@bplmobile.com',
    'Netcom': '[number]@sms.netcom.no',
    'Ntelos': '[number]@pcs.ntelos.com',
    'O2': '[number]@o2imail.co.uk',
    'O2(M-mail)': '[number]@mmail.co.uk',
    'OneConnectAustria': '[number]@onemail.at',
    'OptusMobile': '[number]@optusmobile.com.au',
    'Orange': '[number]@orange.net',
    'OrangeMumbai': '[number]@orangemail.co.in',
    'OrangeNL/Dutchtone': '[number]@sms.orange.nl',
    'Oskar': '[number]@mujoskar.cz',
    'P&TLuxembourg': '[number]@sms.luxgsm.lu',
    'PersonalCommunication': '[number]@pcom.ru',
    'PondicherryBPLMobile': '[number]@bplmobile.com',
    'Primtel': '[number]@sms.primtel.ru',
    'Safaricom': '[number]@safaricomsms.com',
    'SatelindoGSM': '[number]@satelindogsm.com',
    'SCS-900': '[number]@scs-900.ru',
    'SFRFrance': '[number]@sfr.fr',
    'SimpleFreedom': '[number]@text.simplefreedom.net',
    'SmartTelecom': '[number]@mysmart.mymobile.ph',
    'SouthernLINC': '[number]@page.southernlinc.com',
    'SunriseMobile': '[number]@swmsg.com',
    'SurewestCommunications': '[number]@freesurf.ch',
    'Swisscom': '[number]@bluewin.ch',
    'TamilNaduBPLMobile': '[number]@bplmobile.com',
    'UttarPradeshEscotel': '[number]@escotelmobile.com',
    'AmeritechPaging': '[number]@paging.acswireless.com',
    'AT&TPCS': '[number]@mobile.att.net',
    'CellularOne(SouthWest)': '[number]@swmsg.com',
    'IndianaPagingCo': '[number]@inlandlink.com',
    'Primeco': '[number]@email.uscc.net',
    'SBCAmeritechPaging': '[number]@paging.acswireless.com'
};
function getDomain(email) {
    return email.split('@')[email.split('@').length - 1];
}
function getCarrier(email) {
    if (typeof email === 'undefined')
        return null;
    for (var _i = 0, _a = Object.keys(exports.carriers); _i < _a.length; _i++) {
        var carrierName = _a[_i];
        var carrierDomain = getDomain(exports.carriers[carrierName]);
        var emailDomain = getDomain(email);
        if (carrierDomain === emailDomain) {
            return carrierName;
        }
    }
    return null;
}
exports.getCarrier = getCarrier;
function generateEmail(carrier, phoneNumber) {
    if (Object.keys(exports.carriers).indexOf(carrier) === -1) {
        throw new Error('Carrier is unsupported');
    }
    return exports.carriers[carrier].replace('[number]', phoneNumber);
}
exports.generateEmail = generateEmail;
exports.default = exports.carriers;
//# sourceMappingURL=carriers.js.map