"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var merge_1 = __importDefault(require("lodash/merge"));
var carriers_1 = require("./carriers");
var Email_1 = __importDefault(require("./Email"));
var separators_1 = __importDefault(require("./separators"));
var Gators = /** @class */ (function (_super) {
    __extends(Gators, _super);
    function Gators(auth, customSeparators) {
        if (customSeparators === void 0) { customSeparators = []; }
        var _this = _super.call(this) || this;
        _this.email = new Email_1.default(auth);
        _this.separators = separators_1.default.concat(customSeparators);
        return _this;
    }
    Gators.prototype.connect = function () {
        var _this = this;
        this.email.connect();
        this.email.on('imap:connected', function () { return _this.emit('connected'); });
        this.email.on('imap:disconnected', function () { return _this.emit('disconnected'); });
        this.email.on('error', function (err) { return _this.emit('error', err); });
        this.email.on('mail', function (mail) { return _this.handleMail(mail); });
    };
    Gators.prototype.passAlongMail = function (mail) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // Emit an 'email' event because it isn't from an SMS gateway
                return [2 /*return*/, this.emit('email', mail)];
            });
        });
    };
    Gators.prototype.handleMail = function (mail) {
        return __awaiter(this, void 0, void 0, function () {
            var from, firstFromValue, carrier, separatorData, separatedMessage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        from = mail.from;
                        if (!(typeof from === 'undefined')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.passAlongMail(mail)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        firstFromValue = from.value[0];
                        carrier = carriers_1.getCarrier(firstFromValue.address);
                        if (!(carrier === null)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.passAlongMail(mail)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        separatorData = {
                            from: firstFromValue,
                            text: mail.text,
                            attachments: mail.attachments
                        };
                        return [4 /*yield*/, this.runSeparators(carrier, separatorData)
                            // Emit a message event
                        ];
                    case 5:
                        separatedMessage = _a.sent();
                        // Emit a message event
                        this.emit('message', separatedMessage, this.constructReplyFn(separatedMessage.from.address));
                        return [2 /*return*/];
                }
            });
        });
    };
    Gators.prototype.runSeparators = function (carrier, separatorData) {
        return __awaiter(this, void 0, void 0, function () {
            var details, _i, _a, separator, isApplicable, detailsUpdate;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        details = { from: separatorData.from };
                        _i = 0, _a = this.separators;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        separator = _a[_i];
                        return [4 /*yield*/, separator.test(carrier, separatorData)];
                    case 2:
                        isApplicable = _b.sent();
                        if (!isApplicable) return [3 /*break*/, 4];
                        return [4 /*yield*/, separator.execute(separatorData)];
                    case 3:
                        detailsUpdate = _b.sent();
                        merge_1.default(details, detailsUpdate);
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/, details];
                }
            });
        });
    };
    Gators.prototype.constructReplyFn = function (address) {
        var _this = this;
        return function (options) { return __awaiter(_this, void 0, void 0, function () {
            var emailOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        emailOptions = {
                            to: address
                        };
                        if (typeof options === 'string') {
                            emailOptions.text = options;
                        }
                        else {
                            merge_1.default(emailOptions, options);
                            emailOptions.to = address;
                        }
                        return [4 /*yield*/, this.send(emailOptions)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
    };
    // ==============================
    // ======== ADD SEPARATOR =======
    // ==============================
    Gators.prototype.separate = function (separator) {
        // Add the separator to the list of separators
        this.separators.push(separator);
        // Return 'this' so that this command can be chained
        return this;
    };
    // ==============================
    // ========= SEND EMAILS ========
    // ==============================
    Gators.prototype.send = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.email) {
                            throw new Error("The 'start' method was not called prior to sending messages");
                        }
                        return [4 /*yield*/, this.email.sendMail(__assign(__assign({}, options), { subject: options.subject || '', html: "<div dir=\"ltf\">" + options.text + "</div>" }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Gators.prototype.sendText = function (phone, carrier, options) {
        return __awaiter(this, void 0, void 0, function () {
            var emailOptions, email;
            return __generator(this, function (_a) {
                // Handle options being a string
                if (typeof options === 'string') {
                    emailOptions = { to: '', text: options };
                }
                else {
                    emailOptions = options;
                    emailOptions.text = options.body;
                }
                email = carriers_1.generateEmail(carrier, String(phone));
                emailOptions.to = email;
                // Send the text
                return [2 /*return*/, this.send(emailOptions)];
            });
        });
    };
    Gators.carriers = Object.keys(carriers_1.carriers);
    return Gators;
}(events_1.EventEmitter));
exports.default = Gators;
//# sourceMappingURL=gators.js.map